package listener

import (
	"context"
	"log"

	"git.3crabs.ru/VLADIMIR/butler/internal/modules/messenger"
	"git.3crabs.ru/VLADIMIR/butler/internal/services"
	"git.3crabs.ru/VLADIMIR/butler/internal/services/bot"
)

type listenerService struct {
	messenger messenger.IMessenger
	bots      []bot.IBot
}

func NewListener(
	messenger messenger.IMessenger,
	bots []bot.IBot,
) services.IService {
	return &listenerService{
		messenger: messenger,
		bots:      bots,
	}
}

func (s *listenerService) Run(ctx context.Context) error {
	for {
		msg, err := s.messenger.GetMessage(ctx)
		if err != nil {
			if err == context.Canceled {
				return nil
			}
			return err
		}
		for _, b := range s.bots {
			if err := b.Process(ctx, msg); err != nil {
				log.Println(err)
			}
		}
	}
}
